/* -*- c++ -*-
 * TkResolver++ - Psychokinesis testing software
 *
 * Copyright (C) 2009 Robert Ham <rah@bash.sh>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#ifndef __TK_EXP_RESULTS_STORE_H__
#define __TK_EXP_RESULTS_STORE_H__

#include <gtkmm.h>

#include "libtkdb/database.h"

namespace Tk {
  namespace Experimenter {

    class ResultsStore : public Gtk::ToggleToolButton
    {
    private:
      typedef std::list<Tk::Db::ExperimentResult *> Results;
      
      Gtk::Window      &_parent_window;
      Tk::Db::Database *_database;
      Results           _results;
      
      void flush();
    protected:
      virtual void on_toggled();
    public:
      ResultsStore(Gtk::Window &parent, Tk::Db::Database *database);
      ~ResultsStore();
      void store_results(Tk::Db::ExperimentResult *experiment);
    };
      
  } /* namespace Experimenter */
}; /* namespace Tk */




#endif /* __TK_EXP_FLASH_TOGGLE_TOOL_H__ */
