/* -*- c++ -*-
 * TkResolver++ - Psychokinesis testing software
 *
 * Copyright (C) 2009 Robert Ham <rah@bash.sh>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#ifndef __TK_DB_EXPERIMENT_RESULT_H__
#define __TK_DB_EXPERIMENT_RESULT_H__

#include "libtkdb/types.h"
#include "libtkdb/value.h"
#include "libtkresolver/types.h"

namespace Tk {
  namespace Db {
    
    class ExperimentResult
    {
    private:
      Id                   _location_id;
      Ids                  _operators;
      Data::ValueMap       *_properties;
      Tk::Resolver::Result *_result;
    public:
      ExperimentResult(const Id &location_id,
		       const Ids &operators,
		       Data::ValueMap *properties,
		       Tk::Resolver::Result *result);
      ~ExperimentResult();
      const Id &get_location_id() const;
      const Ids &get_operators() const;
      Data::ValueMap *take_properties();
      const Tk::Resolver::Result &get_result() const;
    };

  }; /* namespace Db */
}; /* namespace Tk */

#endif /* __TK_DB_EXPERIMENT_RESULT_H__ */
