/* -*- c++ -*-
 * TkResolver++ - Psychokinesis testing software
 *
 * Copyright (C) 2009 Robert Ham <rah@bash.sh>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include "libtkdbui/null_button.h"

using namespace Tk::Db::Ui;

static const std::string IMAGE_FILE_NAME(std::string(PKGDATADIR) + "/empty-set.svg");

NullButton:: NullButton()
  : Gtk::ToggleButton("Null")
{
  std::string image_file_name();
  
  Glib::RefPtr<Gdk::Pixbuf> pixbuf( Gdk::Pixbuf::create_from_file(IMAGE_FILE_NAME, 16, 16) );
  Gtk::Image *image( Gtk::manage(new Gtk::Image(pixbuf)) );
  set_image(*image);
}
