/* -*- c++ -*-
 * TkResolver++ - Psychokinesis testing software
 *
 * Copyright (C) 2008 Robert Ham <rah@bash.sh>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include "libtkdbui/string_value.h"

using namespace Tk::Db::Ui;

StringValue:: StringValue(const Tk::StringValue &value)
  : Value(Tk::Db::Data::String),
    Gtk::Entry()
{
  if (value.is_valid())
    set_text(value.get_value());
}

void
StringValue:: on_changed()
{
  value_changed();
}

Tk::Db::Data::Value
StringValue:: get_value() const
{
  Tk::String text(get_text());
  
  if (text.size() > 0)
    return text;
  else
    return Tk::Db::Data::Value(Tk::Db::Data::String);
}
