/* -*- c++ -*-
 * TkResolver++ - Psychokinesis testing software
 *
 * Copyright (C) 2009 Robert Ham <rah@bash.sh>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#ifndef __TK_DB_UI_PROPERTY_VALUE_H__
#define __TK_DB_UI_PROPERTY_VALUE_H__

#include <gtkmm.h>

#include "libtkdbui/null_button.h"
#include "libtkdbui/value.h"

namespace Tk {
  namespace Db {
    namespace Ui {
      
      class TernaryValue : public Gtk::HBox
      {
      private:
	NullButton         _null;
	Value             *_value;
	
	void update_sensitivity();
	
      public:
	typedef sigc::signal<void, Tk::Db::Data::Value> SignalValueChanged;
	SignalValueChanged signal_value_changed();
	
      protected:
	SignalValueChanged _signal_value_changed;
	
	void value_changed();
	void null_toggled();
	
      public:
	TernaryValue(Value *value);
      };
      
    } /* namespace Ui */
  } /* namespace Db */
}; /* namespace Tk */

#endif /* __TK_DB_UI_PROPERTY_VALUE_H__ */
