/*
 * TkResolver++ - Psychokinesis testing software
 *
 * Copyright (C) 2004,2009 Robert Ham <rah@bash.sh>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdexcept>

#include "libtkrandom/alea.h"

using namespace Tk::Random;

static const unsigned short USB_VENDOR_ARANEUS      = 0x12d8;
static const unsigned short USB_PRODUCT_ALEA        = 0x0001;
static const unsigned short USB_ENDPOINT_RANDOMNESS = 1;

struct usb_dev_handle * Alea::_handle (0);
pthread_mutex_t         Alea::_lock = PTHREAD_MUTEX_INITIALIZER;

Alea:: Alea(unsigned count)
  : USBDev(count, &_handle, &_lock, USB_ENDPOINT_RANDOMNESS, true)
{
  open(USB_VENDOR_ARANEUS, USB_PRODUCT_ALEA);
}

Retriever *
AleaType:: new_retriever(unsigned count)
{
  return new Alea(count);
}
