/* -*- c++ -*-
 * TkResolver++ - Psychokinesis testing software
 *
 * Copyright (C) 2009 Robert Ham <rah@bash.sh>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#ifndef __TK_RANDOM_PRISTINE_H__
#define __TK_RANDOM_PRISTINE_H__

#include "libtkrandom/block.h"

namespace Tk {
  namespace Random {

    class Pristine : public Block
    {
    private:
      const unsigned _block_size;
    protected:
      virtual unsigned get_block_size();
      virtual Buffer *get_buffer(unsigned char_count);
    public:
      Pristine(unsigned char_count, unsigned block_size = 512);
    };

    class PristineType : public RetrieverType
    {
    public:
      virtual bool is_true_randomness();
      virtual Retriever * new_retriever(unsigned count);
    };

  };
};


#endif /* __TK_RANDOM_PRISTINE_H__ */
