/* -*- c++ -*-
 * TkResolver++ - Psychokinesis testing software
 *
 * Copyright (C) 2009 Robert Ham <rah@bash.sh>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#ifndef __TK_RANDOM_REG1_H__
#define __TK_RANDOM_REG1_H__

#include <usb.h>

#include "libtkrandom/usbdev.h"

namespace Tk {
  namespace Random {

    class Reg1 : public USBDev
    {
    private:
      static struct usb_dev_handle *_handle;
      static pthread_mutex_t        _lock;
    protected:
      virtual void condition_data(char *data, unsigned len, char **data_out, unsigned *len_out);
    public:
      Reg1(unsigned char_count = 0);
    };

    class Reg1Type : public USBDevType
    {
    public:
      virtual Retriever * new_retriever(unsigned count);
    };
  };
  
};


#endif /* __TK_RANDOM_REG1_H__ */
