/* -*- c++ -*-
 * TkResolver++ - Psychokinesis testing software
 *
 * Copyright (C) 2004, 2009 Robert Ham <rah@bash.sh>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#ifndef __TK_RESOLVER_SDL_H__
#define __TK_RESOLVER_SDL_H__

#include <SDL/SDL.h>
namespace Tk {
  namespace Resolver {
    
    class SDL
    {
    private:
      static bool _initialised;
      static void initialise();
    public:
      SDL();
      static void reset();
      static bool check_escape(bool test);
      static void lock(SDL_Surface *surface);
      static void unlock(SDL_Surface *surface);
    };
    
  }; /* namespace Resolver */
}; /* namespace Tk */

#endif /* __TK_RESOLVER_SDL_H__ */
